
********************************************************************************
* replace country names with standard forms
********************************************************************************

gen country_orig = country

replace country = lower(country)

*get rid of special characters and spaces
replace country = subinstr(country, ".","",.)
replace country = subinstr(country, "-","",.)
replace country = subinstr(country, "_","",.)
replace country = subinstr(country, "&","",.)
replace country = subinstr(country, "(","",.)
replace country = subinstr(country, ")","",.)
replace country = subinstr(country, ",","",.)
replace country = subinstr(country, "'","",.)
replace country = subinstr(country, ":","",.)
replace country = subinstr(country, " ","",.)
replace country = subinstr(country, "[","",.) 
replace country = subinstr(country, "]","",.)
replace country = subinstr(country, "","c",.)
replace country = subinstr(country, "repof","",.) if !strpos(country, "korea")
replace country = subinstr(country, "kingdomof","",.)
replace country = subinstr(country, "thefederaldem","",.)

global TAB = char(160) //tabstop
replace country = subinstr(country, "$TAB","",.)

forvalues i = 0(1)9 {  //get rid of numbers
replace country = subinstr(country, "`i'","",.)
}


*adjust country names
//note: make sure to use only strings that are unique (e.g., do not use "congo" or "korea")
replace country = "afghanistan" if strpos(country, "afghanistan")
replace country = "afghanistan" if strpos(country, "afganistan")
replace country = "americansamoa" if strpos(country, "americansamoa")
replace country = "anguilla" if strpos(country, "anguilla")
replace country = "aruba" if strpos(country, "aruba")
replace country = "antiguabarbuda" if strpos(country, "antigua")
replace country = "armenia" if strpos(country, "armenia")
replace country = "azerbaijan" if strpos(country, "azerbaijan")

replace country = "bahamas" if strpos(country, "bahamas")
replace country = "bahrain" if strpos(country, "bahrain")
replace country = "bolivia" if strpos(country, "bolivia")
replace country = "bosniaherzegovina" if strpos(country, "bosnia")
replace country = "brunei" if strpos(country, "brunei")
replace country = "bermuda" if strpos(country, "bermuda")
replace country = "britishvirginislands" if strpos(country, "britishvirginislands")
replace country = "britishvirginislands" if strpos(country, "brvirginisds")

replace country = "channelislands" if strpos(country, "channelislands")
replace country = "caymanislands" if strpos(country, "caymanislands")
replace country = "caymanislands" if strpos(country, "caymanisds")
replace country = "caboverde" if strpos(country, "verde")
replace country = "cocosislands" if strpos(country, "cocosisds")  //Australian territory
replace country = "comoros" if strpos(country, "comoros")

replace country = "centralafricanrep" if strpos(country, "centralafrican")
replace country = "china" if strpos(country, "chinaprmainland")
replace country = "china" if country=="peoplesrepublicofchina"
replace country = "christmasisland" if strpos(country, "christmasisland")
replace country = "christmasisland" if strpos(country, "christmasisds")
replace country = "cookislands" if strpos(country, "cookislands")
replace country = "cookislands" if strpos(country, "cookisds")

replace country = "congo" if strpos(country, "brazzaville")
replace country = "congo" if strpos(country, "congorep")
replace country = "congo" if country=="republicofthecongo"
replace country = "congo" if country=="republicofcongo"
replace country = "congodr" if strpos(country, "kinshasa")
replace country = "congodr" if strpos(country, "congodemrep")
replace country = "congodr" if strpos(country, "democraticrepublicofthecongo")
replace country = "congodr" if strpos(country, "democraticrepublicofcongo")
replace country = "congodr" if strpos(country, "congodemocraticrepublic")
replace country = "congodr" if strpos(country, "congothedemocraticrepublicofthe")
replace country = "congodr" if strpos(country, "congodrc")
replace country = "congodr" if strpos(country, "drofthecongo")
replace country = "congodr" if strpos(country, "demrepofthecongo")

replace country = "curacao" if strpos(country, "curacao")
replace country = "curacao" if strpos(country, "curaçao")
replace country = "cotedivoire" if strpos(country, "ivoire")
replace country = "cotedivoire" if strpos(country, "ivorycoast")
replace country = "czechia" if strpos(country, "czechia")
replace country = "czechia" if strpos(country, "czechrep")

replace country = "dominicanrep" if strpos(country, "dominican")
replace country = "egypt" if strpos(country, "egypt")
replace country = "ethiopia" if strpos(country, "ethiopiaexcludeseritrea")
replace country = "equatorialguinea" if country=="eqguinea"

replace country = "falklandislands" if strpos(country, "falklandislands")
replace country = "falklandislands" if strpos(country, "falklandisdsmalvinas")
replace country = "faroeislands" if strpos(country, "faroeislands")
replace country = "faroeislands" if strpos(country, "faeroeisds")
replace country = "frenchpolynesia" if strpos(country, "frenchpolynesia")

replace country = "gambia" if strpos(country, "gambia")
replace country = "gibraltar" if strpos(country, "gibraltar")
replace country = "greenland" if strpos(country, "greenland")
replace country = "guam" if strpos(country, "guam")
replace country = "guernsey" if strpos(country, "guernsey")

replace country = "hongkong" if strpos(country, "hongkong")
replace country = "iran" if strpos(country, "iran")
replace country = "isleofman" if strpos(country, "isleofman")
replace country = "jersey" if strpos(country, "jersey")
replace country = "kosovo" if strpos(country, "kosovo")

replace country = "netherlands" if strpos(country, "netherlands") & !strpos(country, "antil")

replace country = "northkorea" if strpos(country, "koreadpr")
replace country = "northkorea" if strpos(country, "koreademocraticpeoplesrepof")
replace country = "northkorea" if strpos(country, "koreademocraticpeoplesrepublicof")
replace country = "northkorea" if strpos(country, "koreademrep")
replace country = "northkorea" if strpos(country, "koreadempeople")
replace country = "northkorea" if strpos(country, "koreanorth")
replace country = "northkorea" if strpos(country, "dempeoplesrepofkorea")

replace country = "southkorea" if strpos(country, "korearep")
replace country = "southkorea" if strpos(country, "koreasouth")
replace country = "southkorea" if country=="republicofkorea"
replace country = "southkorea" if country=="repofkorea"
replace country = "southkorea" if country=="koreatherepublicof"

replace country = "kyrgyzstan" if strpos(country, "kyrgyz")
replace country = "laos" if strpos(country, "lao")

replace country = "macau" if strpos(country, "macau")
replace country = "macau" if strpos(country, "macao")
replace country = "macedonia" if strpos(country, "macedon")
replace country = "marshallislands" if strpos(country, "marshallislands")
replace country = "marshallislands" if strpos(country, "marshallisds")

replace country = "micronesia" if strpos(country, "micronesia")
replace country = "moldova" if strpos(country, "moldova")
replace country = "montenegro" if strpos(country, "montenegro") & country!="serbiafrserbia/montenegro"  & country!="yugoslaviafrserbia/montenegr"
replace country = "myanmar" if strpos(country, "burma")
replace country = "myanmar" if strpos(country, "myanmar")

replace country = "newcaledonia" if strpos(country, "newcaledonia")
replace country = "norfolkisland" if strpos(country, "norfolkisland")
replace country = "norfolkisland" if strpos(country, "norfolkisds")
replace country = "northernmarianaislands" if strpos(country, "northernmarianaislands")
replace country = "northernmarianaislands" if strpos(country, "nmarianaisds")

replace country = "palestine " if strpos(country, "palestina")
replace country = "palestine" if strpos(country, "palestinia")
replace country = "papuanewguinea" if strpos(country, "papuaguinea")
replace country = "puertorico" if strpos(country, "puertorico")
replace country = "poland" if strpos(country, "poland")

replace country = "russia" if strpos(country, "russia")
replace country = "reunion" if strpos(country, "runion")
replace country = "reunion" if strpos(country, "réunion")

replace country = "saotomeprincipe" if strpos(country, "prncipe")
replace country = "saotomeprincipe" if strpos(country, "principe")
replace country = "saotomeprincipe" if strpos(country, "sotomand")
replace country = "saotomeprincipe" if strpos(country, "sÃ£otomÃ©prÃ­ncipe")
replace country = "saotomeprincipe" if strpos(country, "saotomeandprincipe")
replace country = "saotomeprincipe" if strpos(country, "sãotomépríncipe")
replace country = "saotomeprincipe" if strpos(country, "sãotoméandpríncipe")
replace country = "saintmartin" if strpos(country, "saintmartin")
replace country = "saintmartin" if strpos(country, "stmartin")
replace country = "serbia" if strpos(country, "serbiarepublicof")
replace country = "saintmartin" if strpos(country, "saintmartin") //French
replace country = "sintmaarten" if strpos(country, "sintmaarten") //Dutch
replace country = "sintmaarten" if strpos(country, "saintmaarten")

replace country = "slovakia" if strpos(country, "slovak") & !strpos(country, "czech")
replace country = "solomonislands" if strpos(country, "solomonis")
replace country = "southsudan" if country=="ssudan"
replace country = "stlucia" if strpos(country, "lucia")
replace country = "stkittsnevis" if strpos(country, "kitts")
replace country = "stvincentgrenadines" if strpos(country, "vincent")
replace country = "syria" if strpos(country, "syria")
replace country = "swaziland" if strpos(country, "eswatini")

replace country = "taiwan" if strpos(country, "taiwan")
replace country = "tanzania" if strpos(country, "tanzania")
replace country = "timorleste" if strpos(country, "easttimor")
replace country = "timorleste" if strpos(country, "timorleste")
replace country = "trinidadtobago" if strpos(country, "trinidad")
replace country = "turksandcaicosislands" if strpos(country, "turksandcaicosislands")
replace country = "turksandcaicosislands" if strpos(country, "turksandcaicosisds")
replace country = "turkey" if strpos(country, "türkiye")
replace country = "turkey" if strpos(country, "turkiye")

replace country = "usa" if country=="unitedstates"
replace country = "usa" if country=="unitedstatesofamerica"
replace country = "unitedarabemirates" if country=="uae"
replace country = "unitedkingdom" if strpos(country, "greatbritain")
replace country = "unitedkingdom" if country=="uk"

replace country = "virginislandsus" if strpos(country, "virginislandsus")
replace country = "virginislandsus" if strpos(country, "unitedstatesvirginislands")
replace country = "venezuela" if strpos(country, "venezuela")
replace country = "palestine" if strpos(country, "westbankandgaza")
replace country = "palestine" if strpos(country, "palestine")
replace country = "palestine" if strpos(country, "palestinia")
replace country = "yemen" if strpos(country, "yemenrep")



*check if real country
merge m:1 country using "countries.dta"
gen dcountry     = (_m==3 | _m==2)
replace dcountry = 99 if _m==2
lab var dcountry "0=no GDP data / 1=ok / 99=missing"
lab define dcountry 0 "not real country (no GDP data)" 1 "ok" 99 "country missing (from GDP data)"
lab values dcountry dcountry
drop _m
sort dcountry country


